diff -Nru sogo-5.0.1/Tests/spec/DAVCalendarAclSpec.js sogo-5.2.0/Tests/spec/DAVCalendarAclSpec.js
--- sogo-5.0.1/Tests/spec/DAVCalendarAclSpec.js	1970-01-01 01:00:00.000000000 +0100
+++ sogo-5.2.0/Tests/spec/DAVCalendarAclSpec.js	2021-08-18 21:35:57.000000000 +0200
@@ -0,0 +1,442 @@
+import config from '../lib/config'
+import WebDAV from '../lib/WebDAV'
+import TestUtility from '../lib/utilities'
+
+describe('create, read, modify, delete events for regular user', function() {
+  const webdav = new WebDAV(config.username, config.password)
+  const webdav_su = new WebDAV(config.superuser, config.superuser_password)
+  const webdav_subscriber = new WebDAV(config.subscriber_username, config.subscriber_password)
+  const utility = new TestUtility(webdav)
+
+  const event_template = `BEGIN:VCALENDAR
+PRODID:-//Inverse//Event Generator//EN
+VERSION:2.0
+BEGIN:VEVENT
+SEQUENCE:0
+TRANSP:OPAQUE
+UID:12345-%(class)-%(filename)
+SUMMARY:%(class) event (orig. title)
+DTSTART:20090805T100000Z
+DTEND:20090805T140000Z
+CLASS:%(class)
+DESCRIPTION:%(class) description
+LOCATION:location
+%(organizer_line)%(attendee_line)CREATED:20090805T100000Z
+DTSTAMP:20090805T100000Z
+END:VEVENT
+END:VCALENDAR`
+
+  const task_template = `BEGIN:VCALENDAR
+PRODID:-//Inverse//Event Generator//EN
+VERSION:2.0
+BEGIN:VTODO
+CREATED:20100122T201440Z
+LAST-MODIFIED:20100201T175246Z
+DTSTAMP:20100201T175246Z
+UID:12345-%(class)-%(filename)
+SUMMARY:%(class) event (orig. title)
+CLASS:%(class)
+DESCRIPTION:%(class) description
+STATUS:IN-PROCESS
+PERCENT-COMPLETE:0
+END:VTODO
+END:VCALENDAR`
+
+  const resource = `/SOGo/dav/${config.username}/Calendar/test-dav-acl/`
+  const classToICSClass = {
+    'pu': 'PUBLIC',
+    'pr': 'PRIVATE',
+    'co': 'CONFIDENTIAL'
+  }
+
+  let user
+
+  const _checkViewEventRight = function(operation, event, eventClass, right) {
+    if (right) {
+      expect(event).toBeTruthy()
+      if (['v', 'r', 'm'].includes(right)) {
+        const iscClass = classToICSClass[eventClass]
+        const expectedEvent = utility.formatTemplate(event_template, {
+          'class': iscClass,
+          'filename': `${iscClass.toLowerCase()}-event.ics`
+        })
+        expect(event).toBe(expectedEvent)
+      }
+      else if (right == 'd') {
+        _testEventIsSecureVersion(eventClass, event)
+      }
+      else {
+        throw new Error(`Right '${right} is not supported`)
+      }
+    }
+    else {
+      expect(event).toBeFalsy()
+    }
+  }
+
+  const _currentUserPrivilegeSet = async function(resource, expectedCode = 207) {
+    const results = await webdav_subscriber.currentUserPrivilegeSet(resource)
+    expect(results.length).toBe(1)
+    const response = results[0]
+    expect(response.status).toBe(expectedCode)
+    let privileges = []
+    if (expectedCode < 300) {
+      privileges = response.props.currentUserPrivilegeSet.privilege.map(o => {
+        return Object.keys(o)[0]
+      })
+    }
+    return privileges
+  }
+
+  const _deleteEvent = async function(client, filename, expectedCode = 204) {
+    const response = await client.deleteObject(resource + filename)
+    expect(response.status).toBe(expectedCode)
+  }
+
+  const _getEvent = async function(eventClass, isInvitation = false) {
+    const iscClass = classToICSClass[eventClass].toLowerCase()
+    const filename = (isInvitation ? `invitation-${iscClass}` : iscClass) + '-event.ics'
+    const [{ status, raw = '' }] = await webdav_subscriber.getEvent(resource, filename)
+
+    if (status == 200)
+      return raw.replace(/\r\n/g,'\n')
+    else
+      return undefined
+  }
+
+  const _multigetEvent = async function(eventClass) {
+    const iscClass = classToICSClass[eventClass].toLowerCase()
+    const filename = `${iscClass}-event.ics`
+    let event = undefined
+    const results = await webdav_subscriber.calendarMultiGet(resource, filename)
+    if (results.status !== 404) {
+      results.find(o => {
+        if (o.href == resource + filename) {
+          const { props: { calendarData = '' } } = o
+          event = calendarData.replace(/\r\n/g,'\n')
+          return true
+        }
+        return false
+      })
+    }
+    return event
+  }
+
+  const _propfindEvent = async function(eventClass) {
+    const iscClass = classToICSClass[eventClass].toLowerCase()
+    const filename = `${iscClass}-event.ics`
+    const results = await webdav_subscriber.propfindEvent(resource + filename)
+    let event = undefined
+    if (results.status !== 404) {
+      results.find(o => {
+        if (o.href == resource + filename) {
+          const { props: { calendarData = '' } } = o
+          event = calendarData.replace(/\r\n/g,'\n')
+          return true
+        }
+        return false
+      })
+    }
+    return event
+  }
+
+  const _putEvent = async function(client, filename, eventClass = 'PUBLIC', expectedCode = 201, organizer, attendee, partstat = 'NEEDS-ACTION') {
+    const organizer_line = organizer ? `ORGANIZER:${organizer}\n` : ''
+    const attendee_line = attendee ? `ATTENDEE;PARTSTAT=${partstat}:${attendee}\n` : ''
+    const event = utility.formatTemplate(event_template, {
+      'class': eventClass,
+      'filename': filename,
+      organizer_line,
+      attendee_line
+    })
+    const response = await client.createCalendarObject(resource, filename, event)
+    expect(response.status).toBe(expectedCode)
+  }
+
+  const _webdavSyncEvent = async function(eventClass) {
+    const iscClass = classToICSClass[eventClass].toLowerCase()
+    const filename = `${iscClass}-event.ics`
+    let event = undefined
+    const results = await webdav_subscriber.syncColletion(resource)
+    if (results.status !== 404) {
+      results.find(o => {
+        if (o.href == resource + filename) {
+          const { props: { calendarData = '' } } = o
+          event = calendarData.length ? calendarData.replace(/\r\n/g,'\n') : undefined
+          return true
+        }
+        return false
+      })
+    }
+    return event
+  }
+
+  const _testCreate = async function(rights) {
+    let expectedCode
+    if (rights.c)
+      expectedCode = 201
+    else if (Object.keys(rights).length === 0)
+      expectedCode = 404
+    else
+      expectedCode = 403
+    return _putEvent(webdav_subscriber, 'creation-test.ics', 'PUBLIC', expectedCode)
+  }
+
+  const _testCollectionDAVAcl = async function(rights) {
+    let expectedPrivileges = []
+    if (Object.keys(rights).length > 0) {
+      expectedPrivileges.push('read', 'readCurrentUserPrivilegeSet', 'readFreeBusy')
+    }
+    if (rights.c) {
+      expectedPrivileges.push(
+        'bind',
+        'writeContent',
+        'schedule',
+        'schedulePost',
+        'schedulePostVevent',
+        'schedulePostVtodo',
+        'schedulePostVjournal',
+        'schedulePostVfreebusy',
+        'scheduleDeliver',
+        'scheduleDeliverVevent',
+        'scheduleDeliverVtodo',
+        'scheduleDeliverVjournal',
+        'scheduleDeliverVfreebusy',
+        'scheduleRespond',
+        'scheduleRespondVevent',
+        'scheduleRespondVtodo'
+      )
+    }
+    if (rights.d) {
+      expectedPrivileges.push('unbind')
+    }
+    const expectedCode = (expectedPrivileges.length == 0) ? 404 : 207
+    const privileges = await _currentUserPrivilegeSet(resource, expectedCode)
+
+    // When comparing privileges on DAV collection, we remove all 'default'
+    // privileges on the collection.
+    for (const c of ['Public', 'Private', 'Confidential']) {
+      for (const r of ['viewdant', 'viewwhole', 'modify', 'respondto']) {
+        const i = privileges.indexOf(`${r}${c}Records`)
+        if (i >= 0) {
+          privileges.splice(i, 1)
+        }
+      }
+    }
+    // for (const privilege of ['read', 'readCurrentUserPrivilegeSet', 'readFreeBusy']) {
+    for (const expectedPrivilege of expectedPrivileges) {
+      expect(privileges).toContain(expectedPrivilege)
+    }
+  }
+
+  const _testEventIsSecureVersion = function(eventClass, event) {
+    const iscClass = classToICSClass[eventClass].toLowerCase().replace(/^\w/, c => c.toUpperCase())
+    const expectedDict = {
+      version: 'VERSION:2.0',
+      prodid: 'PRODID:-//Inverse//Event Generator//EN',
+      summary: `SUMMARY:(${iscClass} event)`,
+      dtstart: 'DTSTART:20090805T100000Z',
+      dtend: 'DTEND:20090805T140000Z',
+      dtstamp: 'DTSTAMP:20090805T100000Z',
+      'x-sogo-secure': 'X-SOGO-SECURE:YES'
+    }
+    const eventDict = utility.versitDict(event)
+    // Ignore UID
+    for (const key of Object.keys(eventDict).filter(k => k !== 'uid')) {
+      expect(expectedDict[key])
+        .withContext(`Key ${key} of secure event is expected`)
+        .toBeTruthy()
+      if (expectedDict[key])
+        expect(expectedDict[key])
+        .withContext(`Value of key ${key} of secure event is valid`)
+        .toBe(eventDict[key])
+    }
+    for (const key of Object.keys(expectedDict)) {
+      expect(eventDict[key])
+        .withContext(`Key ${key} of secure event is present`)
+        .toBeTruthy()
+    }
+  }
+
+  const _testModify = async function(eventClass, right, errorCode) {
+    const iscClass = classToICSClass[eventClass]
+    const filename = `${iscClass.toLowerCase()}-event.ics`
+    let expectedCode = errorCode
+    if (['r', 'm'].includes(right))
+      expectedCode = 204
+    return _putEvent(webdav_subscriber, filename, iscClass, expectedCode)
+  }
+
+  const _testRespondTo = async function(eventClass, right, errorCode) {
+    const iscClass = classToICSClass[eventClass]
+    const filename = `invitation-${iscClass.toLowerCase()}-event.ics`
+    let expectedCode = errorCode
+    if (['r', 'm'].includes(right))
+      expectedCode = 204
+
+    await _putEvent(webdav, filename, iscClass, 201, 'mailto:nobody@somewhere.com', user.email, 'NEEDS-ACTION')
+
+    // here we only do 'passive' validation: if a user has a "respond to"
+    // right, only the attendee entry will me modified. The change of
+    // organizer must thus be silently ignored below.
+    await _putEvent(webdav_subscriber, filename, iscClass, expectedCode, 'mailto:someone@nowhere.com', user.email, 'ACCEPTED')
+
+    if (expectedCode == 204) {
+      const attendee_line = `ATTENDEE;PARTSTAT=ACCEPTED:${user.email}\n`
+      let expectedEvent
+      if (right == 'r') {
+        expectedEvent = utility.formatTemplate(event_template, {
+          'class': iscClass,
+          'filename': filename,
+          organizer_line: 'ORGANIZER;CN=nobody@somewhere.com:mailto:nobody@somewhere.com\n',
+          attendee_line
+        })
+      }
+      else {
+        expectedEvent = utility.formatTemplate(event_template, {
+          'class': iscClass,
+          'filename': filename,
+          organizer_line: 'ORGANIZER;CN=someone@nowhere.com:mailto:someone@nowhere.com\n',
+          attendee_line
+        })
+      }
+      const event = await _getEvent(eventClass, true)
+      expect(utility.calendarsAreEqual(expectedEvent, event))
+        .withContext('Calendars of organizer and attendee are identical')
+        .toBe(true)
+    }
+  }
+
+  const _testEventDAVAcl = async function(eventClass, right, errorCode) {
+    const iscClass = classToICSClass[eventClass].toLowerCase()
+    for (const suffix of ['event', 'task']) {
+      const filename = `${iscClass}-${suffix}.ics`
+      let expectedCode = errorCode
+      let expectedPrivileges = []
+      if (right) {
+        expectedCode = 207
+        expectedPrivileges.push('readCurrentUserPrivilegeSet', 'viewDateAndTime', 'read')
+        if (right != 'd') {
+          expectedPrivileges.push('viewWholeComponent')
+          if (right != 'v') {
+            expectedPrivileges.push('respondToComponent', 'writeContent')
+            if (right != 'r') {
+              expectedPrivileges.push('writeProperties', 'write')
+            }
+          }
+        }
+      }
+      const privileges = await _currentUserPrivilegeSet(resource + filename, expectedCode)
+      if (errorCode != expectedCode) {
+        for (const expectedPrivilege of expectedPrivileges) {
+          expect(privileges).toContain(expectedPrivilege)
+        }
+      }
+    }
+  }
+
+  const _testEventRight = async function(eventClass, rights) {
+    const right = Object.keys(rights).includes(eventClass) ? rights[eventClass] : undefined
+
+    let event = await _getEvent(eventClass)
+    _checkViewEventRight('GET', event, eventClass, right)
+
+    event = await _propfindEvent(eventClass)
+    _checkViewEventRight('PROPFIND', event, eventClass, right)
+
+    event = await _multigetEvent(eventClass)
+    _checkViewEventRight('multiget', event, eventClass, right)
+
+    event = await _webdavSyncEvent(eventClass)
+    _checkViewEventRight('webdav-sync', event, eventClass, right)
+
+    const errorCode = (Object.keys(rights).length > 0) ? 403 : 404
+    await _testModify(eventClass, right, errorCode)
+    await _testRespondTo(eventClass, right, errorCode)
+    await _testEventDAVAcl(eventClass, right, errorCode)
+  }
+
+  const _testDelete = async function(rights) {
+    let expectedCode = 403
+    if (rights && rights.d) {
+      expectedCode = 204
+    }
+    else if (Object.keys(rights) == 0) {
+      expectedCode = 404
+    }
+    for (const eventClass of Object.values(classToICSClass)) {
+      await _deleteEvent(webdav_subscriber, `${eventClass.toLocaleLowerCase()}-event.ics`, expectedCode)
+    }
+  }
+
+  const _testRights = async function(rights) {
+    const results = await utility.setupCalendarRights(resource, config.subscriber_username, rights)
+    expect(results.length).toBe(1)
+    expect(results[0].status).toBe(204)
+    await _testCreate(rights)
+    await _testCollectionDAVAcl(rights)
+    await _testEventRight('pu', rights)
+    await _testEventRight('pr', rights)
+    await _testEventRight('co', rights)
+    await _testDelete(rights)
+  }
+
+  beforeEach(async function() {
+    user = await utility.fetchUserInfo(config.username)
+    await webdav.deleteObject(resource)
+    await webdav.makeCalendar(resource)
+    for (const c of Object.values(classToICSClass)) {
+      // Create event for each class
+      const eventFilename = `${c.toLowerCase()}-event.ics`
+      const event = utility.formatTemplate(event_template, {
+        'class': c,
+        'filename': eventFilename
+      })
+      let response = await webdav.createCalendarObject(resource, eventFilename, event)
+      expect(response.status).toBe(201)
+      // Create task for each class
+      const taskFilename = `${c.toLowerCase()}-task.ics`
+      const task = utility.formatTemplate(task_template, {
+        'class': c,
+        'filename': taskFilename
+      })
+      response = await webdav.createCalendarObject(resource, taskFilename, task)
+      expect(response.status).toBe(201)
+    }
+  })
+
+  afterEach(async function() {
+    await webdav_su.deleteObject(resource)
+  })
+
+  // DAVCalendarAclTest
+
+  it("'view all' on a specific class (PUBLIC)", async function() {
+    await _testRights({ pu: 'v' })
+  })
+
+  it("'modify' PUBLIC, 'view all' PRIVATE, 'view d&t' confidential", async function() {
+    await _testRights({ pu: 'm', pr: 'v', co: 'd' })
+  })
+
+  it("'create' only", async function() {
+    await _testRights({ c: true })
+  })
+
+  it("'delete' only", async function() {
+    await _testRights({ d: true })
+  })
+
+  it("'create', 'delete', 'view d&t' PUBLIC, 'modify' PRIVATE", async function() {
+    await _testRights({ c: true, d: true, pu: 'd', pr: 'm' })
+  })
+
+  it("'create', 'respond to' PUBLIC", async function() {
+    await _testRights({ c: true, pu: 'r' })
+  })
+
+  it("no right given", async function() {
+    await _testRights({})
+  })
+
+})
\ No newline at end of file
diff -Nru sogo-5.0.1/Tests/spec/DAVCalendarPublicAclSpec.js sogo-5.2.0/Tests/spec/DAVCalendarPublicAclSpec.js
--- sogo-5.0.1/Tests/spec/DAVCalendarPublicAclSpec.js	1970-01-01 01:00:00.000000000 +0100
+++ sogo-5.2.0/Tests/spec/DAVCalendarPublicAclSpec.js	2021-08-18 21:35:57.000000000 +0200
@@ -0,0 +1,181 @@
+import config from '../lib/config'
+import WebDAV from '../lib/WebDAV'
+import TestUtility from '../lib/utilities'
+
+describe('public access', function() {
+  const webdav = new WebDAV(config.username, config.password)
+  const webdav_anon = new WebDAV()
+  const webdav_su = new WebDAV(config.superuser, config.superuser_password)
+  const webdav_subscriber = new WebDAV(config.subscriber_username, config.subscriber_password)
+  const utility = new TestUtility(webdav)
+  const utility_subscriber = new TestUtility(webdav_subscriber)
+  let createdRsrc
+
+  // DAVCalendarPublicAclTest
+
+  afterEach(async function() {
+    if (createdRsrc) {
+      await webdav_su.deleteObject(createdRsrc)
+    }
+  })
+
+  it("normal user access to (non-)shared resource from su", async function() {
+    const parentColl = `/SOGo/dav/${config.username}/Calendar/`
+    let results
+    let href
+
+    // 1. all rights removed
+    createdRsrc = `${parentColl}test-dav-acl/`
+    for (const rsrc of ['personal', 'test-dav-acl']) {
+      const resource = `${parentColl}${rsrc}/`
+      await webdav.makeCalendar(resource)
+      await utility.setupRights(resource, 'anonymous', {})
+      await utility.setupRights(resource, config.subscriber_username, {})
+      await utility.setupRights(resource, '<default>', {})
+    }
+
+    results = await webdav_subscriber.propfindURL(parentColl)
+    expect(results.length)
+      .withContext(`Profind returns 1 href when subscriber user ${config.subscriber_username} has no right`)
+      .toBe(1)
+    href = results[0].href
+    expect(href)
+      .withContext(`Unique href must be the Calendar parent collection ${parentColl}`)
+      .toBe(parentColl)
+
+    // 2. creation right added
+    await utility.setupCalendarRights(createdRsrc, config.subscriber_username, { c: true })
+
+    results = await webdav_subscriber.propfindURL(parentColl)
+    expect(results.length)
+      .withContext(`Profind returns 4 href when subscriber user ${config.subscriber_username} has creation right`)
+      .toBe(4)
+    href = results[0].href
+    expect(href)
+      .withContext(`First href must be the Calendar parent collection ${parentColl}`)
+      .toBe(parentColl)
+
+    let resourceHrefs = {
+      [createdRsrc]: false,
+      [`${createdRsrc.slice(0, -1)}.xml`]: false,
+      [`${createdRsrc.slice(0, -1)}.ics`]: false
+    }
+    for (href of results.map(r => r.href).slice(1)) {
+      expect(Object.keys(resourceHrefs).includes(href))
+        .withContext(`Propfind href ${href} is returned`)
+        .toBeTrue()
+      expect(resourceHrefs[href])
+        .not.toBeTrue()
+      resourceHrefs[href] = true
+    }
+
+    await utility.setupRights(createdRsrc, config.subscriber_username) // remove rights
+
+    // 3. creation right added for "default user"
+    //    subscriber_username expected to have access, but not "anonymous"
+    await utility.setupCalendarRights(createdRsrc, '<default>', { c: true })
+
+    results = await webdav_subscriber.propfindURL(parentColl)
+    expect(results.length)
+      .withContext('Profind returns 4 href when <default> user has creation right')
+      .toBe(4)
+    href = results[0].href
+    expect(href)
+      .withContext('First href must be the Calendar parent collection')
+      .toBe(parentColl)
+
+    resourceHrefs = {
+      [createdRsrc]: false,
+      [`${createdRsrc.slice(0, -1)}.xml`]: false,
+      [`${createdRsrc.slice(0, -1)}.ics`]: false
+    }
+    for (href of results.map(r => r.href).slice(1)) {
+      expect(Object.keys(resourceHrefs).includes(href))
+        .withContext(`Propfind href ${href} is returned`)
+        .toBeTrue()
+      expect(resourceHrefs[href])
+        .withContext(`Propfind href ${href} is returned only once`)
+        .not.toBeTrue()
+      resourceHrefs[href] = true
+    }
+
+    const anonParentColl = `/SOGo/dav/public/${config.username}/Calendar/`
+    results = await webdav_anon.propfindURL(anonParentColl)
+    expect(results.length)
+      .withContext('Profind returns 1 href for anonymous user')
+      .toBe(1)
+    href = results[0].href
+    expect(href)
+      .withContext('Unique href must be the Calendar parent collection')
+      .toBe(anonParentColl)
+
+    await utility.setupRights(createdRsrc, '<default>', {})
+
+    // 4. creation right added for "anonymous"
+    //    "anonymous" expected to have access, but not subscriber_username
+
+    await utility.setupCalendarRights(createdRsrc, 'anonymous', { c: true })
+
+    results = await webdav_anon.propfindURL(anonParentColl)
+    expect(results.length)
+      .withContext('Profind returns 4 href when anonymous user has creation right')
+      .toBe(4)
+    href = results[0].href
+    expect(href)
+      .withContext('First href must be the Calendar parent collection')
+      .toBe(anonParentColl)
+
+    const anonRsrc = `${anonParentColl}test-dav-acl/`
+    resourceHrefs = {
+      [anonRsrc]: false,
+      [`${anonRsrc.slice(0, -1)}.xml`]: false,
+      [`${anonRsrc.slice(0, -1)}.ics`]: false
+    }
+    for (href of results.map(r => r.href).slice(1)) {
+      expect(Object.keys(resourceHrefs).includes(href))
+        .withContext(`Propfind href ${href} is returned`)
+        .toBeTrue()
+      expect(resourceHrefs[href])
+        .withContext(`Propfind href ${href} is returned only once`)
+        .not.toBeTrue()
+      resourceHrefs[href] = true
+    }
+
+    results = await webdav_subscriber.propfindURL(parentColl)
+    expect(results.length)
+      .withContext('Profind returns 1 href when <default> user has no right')
+      .toBe(1)
+    href = results[0].href
+    expect(href)
+      .withContext('First href must be the Calendar parent collection')
+      .toBe(parentColl)
+
+  })
+
+  it("user accessing (non-)shared Calendars", async function() {
+    const parentColl = `/SOGo/dav/${config.subscriber_username}/Calendar/`
+    let results
+
+    createdRsrc = `${parentColl}test-dav-acl/`
+    for (const rsrc of ['personal', 'test-dav-acl']) {
+      const resource = `${parentColl}${rsrc}/`
+      await webdav_su.makeCalendar(resource)
+      await utility_subscriber.setupRights(resource, config.username, {})
+    }
+
+    results = await webdav_subscriber.propfindURL(parentColl)
+    const hrefs = results.map(r => r.href).filter(h => {
+      return h == `${parentColl}` ||
+        h.indexOf(`${parentColl}personal`) == 0 ||
+        h.indexOf(`${parentColl}test-dav-acl`) == 0
+    })
+    expect(hrefs.length)
+      .withContext(`Profind returns at least 3 hrefs when user ${config.subscriber_username} is the owner`)
+      .toBeGreaterThan(2)
+    const [href] = hrefs
+    expect(href)
+      .withContext('Unique href must be the Calendar parent collection')
+      .toBe(parentColl)
+  })
+
+})
\ No newline at end of file
diff -Nru sogo-5.0.1/Tests/spec/DAVCalendarSuperUserAclSpec.js sogo-5.2.0/Tests/spec/DAVCalendarSuperUserAclSpec.js
--- sogo-5.0.1/Tests/spec/DAVCalendarSuperUserAclSpec.js	1970-01-01 01:00:00.000000000 +0100
+++ sogo-5.2.0/Tests/spec/DAVCalendarSuperUserAclSpec.js	2021-08-18 21:35:57.000000000 +0200
@@ -0,0 +1,116 @@
+import config from '../lib/config'
+import WebDAV from '../lib/WebDAV'
+import TestUtility from '../lib/utilities'
+
+describe('DAVCalendarSuperUserAcl', function() {
+  const webdav = new WebDAV(config.username, config.password)
+  const webdav_su = new WebDAV(config.superuser, config.superuser_password)
+  const utility = new TestUtility(webdav)
+
+  const event_template = `BEGIN:VCALENDAR
+PRODID:-//Inverse//Event Generator//EN
+VERSION:2.0
+BEGIN:VEVENT
+SEQUENCE:0
+TRANSP:OPAQUE
+UID:12345-%(class)-%(filename)
+SUMMARY:%(class) event (orig. title)
+DTSTART:20090805T100000Z
+DTEND:20090805T140000Z
+CLASS:%(class)
+DESCRIPTION:%(class) description
+LOCATION:location
+%(organizer_line)%(attendee_line)CREATED:20090805T100000Z
+DTSTAMP:20090805T100000Z
+END:VEVENT
+END:VCALENDAR`
+
+  const resource = `/SOGo/dav/${config.subscriber_username}/Calendar/test-dav-superuser-acl/`
+  const filename = 'suevent.ics'
+
+  const event = utility.formatTemplate(event_template, {
+    'class': 'PUBLIC',
+    'filename': filename
+  })
+
+  beforeAll(async function() {
+    await webdav_su.deleteObject(resource)
+    await webdav_su.makeCalendar(resource)
+  })
+
+  afterAll(async function() {
+    await webdav_su.deleteObject(resource)
+  })
+
+  // DAVCalendarSuperUserAclTest.testSUAccess
+  it("create, read, modify, delete for superuser", async function() {
+    let result, results
+
+    // 1. Create
+
+    result = await webdav_su.createCalendarObject(resource, filename, event)
+    expect(result.status)
+      .withContext('Event creation returns status code 201')
+      .toBe(201)
+
+    // 2. Read - GET
+
+    results = await webdav_su.getEvent(resource, filename)
+    expect(results.length).toBe(1)
+    expect(results[0].raw.replace(/\r\n/g,'\n')).toBe(event)
+
+    // 2. Read - PROPFIND calendar-data
+
+    results = await webdav_su.propfindEvent(resource + filename)
+    expect(results.length).toBe(2) // suevent.ics + suevent.ics/master
+    expect(results.find(o => {
+      if (o.href == resource + filename) {
+        expect(o.props.calendarData.replace(/\r\n/g,'\n')).toBe(event)
+        return true
+      }
+      return false
+    })).toBeTruthy()
+
+    // 2. Read - REPORT calendar-multiget
+
+    results = await webdav_su.calendarMultiGet(resource, filename)
+    expect(results.length).toBe(1)
+    expect(results.find(o => {
+      if (o.href == resource + filename) {
+        expect(o.props.calendarData.replace(/\r\n/g,'\n')).toBe(event)
+        return true
+      }
+      return false
+    })).toBeTruthy()
+
+    // 2. Read - webdav-sync
+
+    results = await webdav_su.syncColletion(resource)
+    expect(results.length).toBe(1)
+    expect(results.find(o => {
+      expect(o.status).toBe(201)
+      if (o.href == resource + filename) {
+        expect(o.props.calendarData.replace(/\r\n/g,'\n')).toBe(event)
+        return true
+      }
+      return false
+    })).toBeTruthy()
+
+    // 3. Modify
+
+    const classes = ['CONFIDENTIAL', 'PRIVATE', 'PUBLIC']
+    for (const c of classes) {
+      const event = utility.formatTemplate(event_template, {
+        'class': c,
+        'filename': filename
+      })
+      const response = await webdav_su.createCalendarObject(resource, filename, event)
+      expect(response.status).toBe(204)
+    }
+
+    // 4. Delete
+    const response = await webdav_su.deleteObject(resource)
+    expect(response.status).toBe(204)
+  })
+
+})
\ No newline at end of file
diff -Nru sogo-5.0.1/Tests/spec/DAVPublicAccessSpec.js sogo-5.2.0/Tests/spec/DAVPublicAccessSpec.js
--- sogo-5.0.1/Tests/spec/DAVPublicAccessSpec.js	1970-01-01 01:00:00.000000000 +0100
+++ sogo-5.2.0/Tests/spec/DAVPublicAccessSpec.js	2021-08-18 21:35:57.000000000 +0200
@@ -0,0 +1,39 @@
+import config from '../lib/config'
+import WebDAV from '../lib/WebDAV'
+
+describe('public access', function() {
+  const webdav_anon = new WebDAV()
+
+  // DAVPublicAccessTest
+
+  it("access to /SOGo/so/public", async function() {
+    const [{ status }] = await webdav_anon.options('/SOGo/so/public')
+    expect(status)
+      .withContext('/SOGo/so/public must not be accessible')
+      .toBe(404)
+  })
+
+  it("access to /SOGo/public", async function() {
+    const [{ status }] = await webdav_anon.options('/SOGo/public')
+    expect(status)
+      .withContext('/SOGo/public must not be accessible')
+      .toBe(404)
+  })
+
+  it("access to non-public resource", async function() {
+    const [{ status }] = await webdav_anon.options(`/SOGo/dav/${config.username}`)
+    expect(status)
+      .withContext('DAV non-public resources should request authentication')
+      .toBe(401)
+  })
+
+  it("access to public resource", async function() {
+    const [{ status }] = await webdav_anon.options('/SOGo/dav/public')
+    expect(status)
+      .withContext('DAV public resources must not request authentication')
+      .not.toBe(401)
+    expect(status)
+      .withContext('DAV public resources must be accessible')
+      .toBe(200)
+  })
+})
\ No newline at end of file
